import time
import functools
from typing import Callable


def timeit(f: Callable) -> Callable:
    """Decorator that prints the duration of the decorated function."""
    @functools.wraps(f)
    def wrapper(*args, **kwargs):
        s = time.time()
        r = f(*args, **kwargs)
        print(f'{f.__name__} took {time.time() - s:1.3f}s.')
        return r
    return wrapper
